DECLARE SUB PlayWaveVoice ()
DECLARE SUB LoadWaveVoice (WaveVoiceFile$)
DECLARE FUNCTION DSPVersion! ()
DECLARE FUNCTION SpeakerStatus% ()
DECLARE FUNCTION DMAStatus% ()
DECLARE FUNCTION DMADone% ()
DECLARE FUNCTION ResetDSP% ()
DECLARE FUNCTION ReadDSP% ()
DECLARE FUNCTION ReadDAC% ()

DECLARE SUB FMVolume (right%, left%, Getvol%)
DECLARE SUB VocVolume (right%, left%, Getvol%)
DECLARE SUB MasterVolume (right%, left%, Getvol%)
DECLARE SUB MicVolume (Gain%, Getvol%)
DECLARE SUB LineVolume (right%, left%, Getvol%)
DECLARE SUB CDVolume (right%, left%, Getvol%)
DECLARE SUB InputSource (InputSrc%, GetSrc%)
DECLARE SUB WriteDSP (byte%)
DECLARE SUB SetStereo (OnOff%)
DECLARE SUB WriteDAC (byte%)
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAState (StopGo%)
DECLARE SUB DMAPlay (Segment&, Offset&, Length&, Freq&)
DECLARE SUB DMARecord (Segment&, Offset&, Length&, Freq&)
DECLARE SUB GetBLASTER (DMA%, BasePort%, IRQ%)
DECLARE SUB SetReg (Reg%, value%)

DECLARE SUB SBInit ()
DECLARE SUB PlayMusic ()
DECLARE SUB CloseChannels ()
DECLARE SUB SetIns (Channel%)
DECLARE SUB WriteReg (Reg%, value%)
DECLARE FUNCTION LoadJamFile% (File$)

'$DYNAMIC

COMMON SHARED BasePort%, LenPort%, Channel%

CONST Baseaddr = &H220
CONST RegAddr = Baseaddr + 8, DataAddr = Baseaddr + 9
CONST MaxPlay% = -1

TYPE InsType
 MMult AS INTEGER
 MLevel AS INTEGER
 MAttack AS INTEGER
 MSustain AS INTEGER
 CMult AS INTEGER
 CLevel AS INTEGER
 CAttack AS INTEGER
 CSustain AS INTEGER
END TYPE

TYPE ChannelType
 Defined AS INTEGER
 Speed AS SINGLE
 SongPtr AS INTEGER
 PStat AS SINGLE
 Octave AS INTEGER
 WaveForm AS INTEGER
 Flag AS INTEGER
 Flag2 AS INTEGER
 IsPlaying AS INTEGER
 IsDone AS INTEGER
END TYPE

DIM SHARED MaxChannel%, MaxNotes%
DIM SHARED ChannelStat(1 TO 2) AS ChannelType
DIM SHARED Songbuf(1 TO 2) AS INTEGER
DIM SHARED CurrentIns AS InsType

