
SCREEN 12
TIMER ON
COLOR 3
LOCATE 3, 17
PRINT " Motion of two deuterones in a magnetic field "
LOCATE 5, 17
PRINT "         such as a Magnetic Cocoon "
COLOR 15
ON TIMER(3) GOSUB 1
DO WHILE INKEY$ = "": LOOP

1
CLS
DIM XP1(150), XP2(150)
C$ = " #.###^^^^"
Pi = 3.141593
Eo = 8.85E-12
Mo = 4 * Pi * .0000001
M = 1.67E-27 * 2
Q = 1.6E-19
E = 700!      '[eV]
J = 8E+08
LOCATE 3, 10
INPUT "ANGLE (30 - 170)="; AN
IF 170 < AN GOTO 1
IF AN < 30 GOTO 1
TV = AN * Pi / 180
        V = SQR(2 * E * ABS(Q) / M)
        Vx1 = V * COS(TV)
        Vy1 = V * SIN(TV)
        Vz1 = 0
         Vx2 = Vx1
         Vy2 = -Vy1
dlq = .0001
A = .007
Xv1 = 0
Yv1 = .0003
 Xv2 = 0
 Yv2 = -.0003
L = .25
DL = .01
N = L / DL
Du = .06
S = Pi * Du ^ 2 / 4
IL = S * J
K = Mo / (4 * Pi)
        FOR I = 0 TO N - 1
        XP1(I) = -I * DL - DL / 2 - A
        XP2(I) = I * DL + DL / 2 + A
        NEXT I
FOR t = 0 TO 3000
IL = S * J
K1 = 5000000!
dt = dlq / V
LOCATE 2, 65
PRINT "t ="; USING C$; t * dt
        PXx1 = 0
        PXy1 = 0
        PXx2 = 0
        PXy2 = 0
        PCx1 = 0
        PCy1 = 0
        PCx2 = 0
        PCy2 = 0
        FOR I = 0 TO N - 1
        Rx11 = Xv1 - XP1(I)
        Rx12 = Xv1 - XP2(I)
         Rx21 = Xv2 - XP1(I)
         Rx22 = Xv2 - XP2(I)
                Ux = DL
                REM  Uy = 0 Uz = 0
                Ry1 = Yv1
                Ry2 = Yv2
                
                 R11 = SQR(Rx11 * Rx11 + Ry1 * Ry1)
                 R12 = SQR(Rx12 * Rx12 + Ry1 * Ry1)
                  R21 = SQR(Rx21 * Rx21 + Ry2 * Ry2)
                  R22 = SQR(Rx22 * Rx22 + Ry2 * Ry2)
                    RGx1 = Xv1 - Xv2
                    RGy1 = Yv1 - Yv2
                    RG1 = SQR(RGx1 ^ 2 + RGy1 ^ 2)
                    RGx2 = -RGx1
                    RGy2 = -RGy1
                    RG2 = RG1
               
                REM Hx1 =  (Uy * Rz - Ry * Uz) / R1 ^ 3
                REM Hy1 =  (Uz * Rx1 - Rz * Ux) / R1 ^ 3
                REM Hz1 =  (Ux * Ry - Rx1 * Uy) / R1 ^ 3
               
                Hz11 = (Ux * Ry1) / R11 ^ 3
                Hz12 = (Ux * Ry1) / R12 ^ 3
                 Hz21 = (Ux * Ry2) / R21 ^ 3
                 Hz22 = (Ux * Ry2) / R22 ^ 3

                 REM Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                 REM Py = (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                 REM Pz = (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)
                 
        PGx1 = RGx1 / (ABS(RG1 ^ 3)) * K1
        PGy1 = RGy1 / (ABS(RG1 ^ 3)) * K1
        PGx2 = RGx2 / (ABS(RG2 ^ 3)) * K1
        PGy2 = RGy2 / (ABS(RG2 ^ 3)) * K1
'Coefficient "K1" imitates group of particles
                Px1 = Vy1 * (Hz11 + Hz12)
                Py1 = -(Hz11 + Hz12) * Vx1
                 Px2 = Vy2 * (Hz21 + Hz22)
                 Py2 = -(Hz21 + Hz22) * Vx2
                
                PCx1 = PCx1 + PGx1
                PCy1 = PCy1 + PGy1
                 PCx2 = PCx2 + PGx2
                 PCy2 = PCy2 + PGy2
               
                 PXx1 = PXx1 + Px1
                 PXy1 = PXy1 + Py1
                  PXx2 = PXx2 + Px2
                  PXy2 = PXy2 + Py2
           
            NEXT I
        dVx1 = Q * K * IL * PXx1 * dt / M
        dVy1 = Q * K * IL * PXy1 * dt / M
         dVx2 = Q * K * IL * PXx2 * dt / M
         dVy2 = Q * K * IL * PXy2 * dt / M
        
          Vxt1 = Vx1 + dVx1
          Vyt1 = Vy1 + dVy1
          Vt1 = SQR(Vxt1 ^ 2 + Vyt1 ^ 2)
          kV1 = V / Vt1
         
           Vxt2 = Vx2 + dVx2
           Vyt2 = Vy2 + dVy2
           Vt2 = SQR(Vxt2 ^ 2 + Vyt2 ^ 2)
           kV2 = V / Vt2
'kV - the particle must have a constant value modulo of velocity
        dVCx1 = Q ^ 2 * PCx1 * dt / M / (4 * Pi * Eo)
        dVCy1 = Q ^ 2 * PCy1 * dt / M / (4 * Pi * Eo)
        dVCx2 = Q ^ 2 * PCx2 * dt / M / (4 * Pi * Eo)
         dVCy2 = Q ^ 2 * PCy2 * dt / M / (4 * Pi * Eo)
        
        Vx1 = Vxt1 * kV1 + dVCx1
        Vy1 = Vyt1 * kV1 + dVCy1
         Vx2 = Vxt2 * kV2 + dVCx2
         Vy2 = Vyt2 * kV2 + dVCy2
        Vt = SQR(Vx1 ^ 2 + Vy1 ^ 2 + Vz1 ^ 2)
             
          REM LOCATE 23, 20
          REM PRINT "Vt ="; USING C$; Vt
       
        dXv1 = Vx1 * dt
        dYv1 = Vy1 * dt
         dXv2 = Vx2 * dt
         dYv2 = Vy2 * dt
    
          Xv1 = Xv1 + dXv1
          Yv1 = Yv1 + dYv1
           Xv2 = Xv2 + dXv2
           Yv2 = Yv2 + dYv2
          
     PSET (Xv1 * 70000 + 320, Yv1 * 60000 + 240), 9
     PSET (Xv2 * 70000 + 320, Yv2 * 60000 + 240), 12
    
     IF t = 2000 THEN CLS 1
     IF t = 5000 THEN CLS 1
     IF t = 6500 THEN CLS 1
NEXT t
LOCATE 29, 5
INPUT "repeat under other angle - 1  "; U1
IF U1 = 1 THEN GOTO 1
IF U1 <> 1 THEN END

